package org.snap.dresources;

import java.util.*;

import org.planet.p2pcm.*;

import dermi.*;
import dermi.core.*;
import dermi.exception.*;
import dermi.annotation.*;

@DermiRemoteInterface
public interface Resources extends ComponentInterface {
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void addFolder(Vector<String> path, String name) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void addFile(Vector<String> path, String name, Id hash, String storage) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public void delete(Vector<String> path, String name, DHTHandler dht) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public Collection getResources(Vector<String> path) throws RemoteException;

	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public ResourcesElem getResource(Vector<String> path, String name) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public ResourcesElem.ElemType getResourceType(Vector<String> path, String name) throws RemoteException;
	
	@RemoteMethod (granularity = Granularity.MULTICALL, type = SynchronyType.SYNCHRONOUS)
	public boolean test() throws RemoteException;
}
